<template>
  <div class="container-small">
    <vue-headful
      v-if="!this.$parent.loading"
      :title="$t('Login.forgot')"
    />
    <h1>{{ $t('Login.forgot') }}</h1>

    <form method="post" v-on:submit.prevent="changePass" v-if="change_form">
      <strong>{{ $t('Profile.changePwd') }}</strong>
      <p class="red mtop" v-if="this.onePassword">{{ $t('LostPass.changePassword') }}</p>

      <p class="input-large">
        <input type="password" id="pwd" :placeholder="$t('Profile.newPwd')" v-model="fields.pass" v-focus>
        <label class="fa fa-lock" for="pwd" aria-hidden="true"></label>
      </p>

      <p class="input-large">
        <input type="password" id="pwd_confirm" :placeholder="$t('Register.confirm')" v-model="fields.pass_confirm">
        <label class="fa fa-lock" for="pwd_confirm" aria-hidden="true"></label>
      </p>

      <p class="input-large mtop" v-if="this.onePassword">
        <input type="checkbox" id="resetConfirm" v-model="resetConfirm">
        <label for="resetConfirm">{{ $t('LostPass.resetData') }}</label>
      </p><br>

      <input type="submit" class="btn btn-required btn-warning" :value="$t('Global.submit')" :disabled="!isComplete">

      <template v-if="!this.onePassword">
        <p class="mtop"></p>
        <br><strong>{{ $t('Profile.changePp') }}</strong>
        <p class="red mtop">{{ $t('LostPass.changeSecret') }}</p>

        <p class="input-large">
          <input type="password" id="pp" :placeholder="$t('Profile.newPp')" v-model="fields.pp">
          <label class="fa fa-lock" for="pp" aria-hidden="true"></label>
        </p>

        <p class="input-large">
          <input type="password" id="pp_confirm" :placeholder="$t('Register.confirm')" v-model="fields.pp_confirm">
          <label class="fa fa-lock" for="pp_confirm" aria-hidden="true"></label>
        </p>

        <p class="input-large mtop">
          <input type="checkbox" id="resetConfirm" v-model="resetConfirm">
          <label for="resetConfirm">{{ $t('LostPass.resetData') }}</label>
        </p><br>

        <input type="submit" class="btn btn-required btn-warning" :value="$t('Global.submit')" :disabled="!isComplete">
      </template>
    </form>

    <form method="post" v-on:submit.prevent="sendForm" v-if="send_form">
      <p class="input-large">
        <input type="text" id="user" :placeholder="$t('LostPass.user')" v-model="username" required v-focus>
        <label class="fa fa-user" for="user" aria-hidden="true"></label>
      </p>

      <div class="bloc-links">
        <router-link to="/login" class="mono blue">{{ $t('Login.signIn') }}</router-link>
        <input type="submit" class="btn btn-required" :value="$t('Global.submit')">
      </div>
    </form>

    <p class="red return" v-if="this.err_msg">{{ $t(this.err_msg) }}</p>
    <p class="green return" v-if="this.success_msg">{{ $t(this.success_msg) }}</p>
    <img src="../assets/img/index/loader.svg" class="loader" v-if="loading">
  </div>
</template>

<script>
import sjcl from 'sjcl'
import base64 from 'hi-base64'
import muiHash from '../mui_hash'

let randomString = function (length, chars) {
  // Thanks to Nimphious
  // Code found on stackoverflow (sometimes it's good to be lazy)
  let mask = ''
  if (chars.indexOf('a') > -1) mask += 'abcdefghijklmn!@#$%^&*()_+-={}[]";\'<>?,opqrstuvwxyz'
  if (chars.indexOf('A') > -1) mask += 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
  if (chars.indexOf('#') > -1) mask += '0123456789'
  if (chars.indexOf('!') > -1) mask += '~`!@#$%^&*()_+-={}[]";\'<>?,'
  let result = ''
  for (var i = length; i > 0; --i) result += mask[Math.floor(Math.random() * mask.length)]
  return result
}

export default {
  name: 'LostPass',
  data () {
    return {
      loading: false,
      change_form: false,
      send_form: true,
      err_msg: null,
      success_msg: null,
      username: '',
      uid: null,
      key: null,
      onePassword: false,
      resetConfirm: false,
      fields: {pass: '', pass_confirm: '', pp: '', pp_confirm: ''}
    }
  },
  methods: {
    changePass () {
      this.success_msg = null
      if (this.fields.pass.length === 0 && this.fields.pp.length === 0) {
        this.err_msg = 'Register.passLength'
      } else if (this.fields.pass.length > 0 && this.fields.pass !== this.fields.pass_confirm) {
        this.err_msg = 'Register.badPassConfirm'
      } else if (this.fields.pp.length > 0 && this.fields.pp !== this.fields.pp_confirm) {
        this.err_msg = 'Register.badPassphraseConfirm'
      } else if ((this.fields.pass.length > 0 && this.fields.pass.length < 6) || (this.fields.pp.length > 0 && this.fields.pp.length < 6)) {
        this.err_msg = 'Register.passLength'
      } else {
        let request = {uid: this.uid, key: this.key}
        if (this.fields.pass.length > 0) {
          request.password = this.fields.pass
          if (this.onePassword) {
            request.salt = sjcl.codec.base64.fromBits(sjcl.random.randomWords(4))
            request.password = sjcl.codec.base64.fromBits(sjcl.misc.pbkdf2(request.password, request.salt, 7000, 256))
            request.cek = this.generateCEK()
          }
          request.password = muiHash(request.password)
        }
        if (this.fields.pp.length > 0) {
          request.cek = this.generateCEK()
        }
        this.loading = true
        this.success_msg = null
        this.err_msg = null
        this.$http.post('lostpass', request).then((res) => {
          this.loading = false
          this.change_form = false
          this.success_msg = 'LostPass.updateOk'
          setTimeout(() => {
            this.$router.push('/login')
          }, 1000)
        }, (res) => {
          this.loading = false
          this.err_msg = 'LostPass.keyErr'
          this.change_form = false
          this.send_form = true
        })
      }
    },
    sendForm () {
      if (this.username.length > 0) {
        this.loading = true
        this.$http.post('lostpass/mail', {'username': this.username}).then((res) => {
          this.loading = false
          this.err_msg = null
          this.success_msg = null
          if (res.body.message === 'sent') {
            this.success_msg = 'Global.mailSent'
          } else if (res.body.message === 'wait') {
            this.err_msg = 'LostPass.wait'
          } else {
            this.err_msg = 'Error.default'
          }
        }, (res) => {
          this.loading = false
          if (res.body.message === 'unknownUser') {
            this.err_msg = 'LostPass.notFound'
          } else {
            this.err_msg = 'Error.default'
          }
        })
      }
    },
    generateCEK () {
      let key = randomString(32, '#A!')
      // crypto parameters
      let a = sjcl.random.randomWords(4) // authentication data - 128 bits
      let i = sjcl.random.randomWords(4) // initialization vector - 128 bits
      let s = sjcl.random.randomWords(4) // salt - 128 bits
      // encrypt it
      let cek = sjcl.encrypt(
        this.onePassword ? this.fields.pass : this.fields.pp,
        key,
        {mode: 'gcm', iv: i, salt: s, iter: 7000, ks: 256, adata: a, ts: 128}
      )
      return base64.encode(cek) // don't store a Json in DB...
    }
  },
  computed: {
    isComplete () {
      if (this.onePassword && this.resetConfirm && this.fields.pass.length >= 6 && this.fields.pass_confirm.length >= 6) {
        return true
      } else if (!this.onePassword) {
        if (this.fields.pass.length >= 6 && this.fields.pass_confirm.length >= 6 && this.fields.pp.length === 0 && this.fields.pp_confirm.length === 0) {
          return true
        } else if (this.resetConfirm && this.fields.pp.length >= 6 && this.fields.pp_confirm.length >= 6) {
          if ((this.fields.pass.length === 0 && this.fields.pass_confirm.length === 0) || (this.fields.pass.length >= 6 && this.fields.pass_confirm.length >= 6)) {
            return true
          }
        }
      }
      return false
    }
  },
  created () {
    if (this.$parent.isLogged()) {
      this.$router.push('/')
      return false
    }

    if (typeof this.$route.params.uid !== 'undefined' && typeof this.$route.params.key !== 'undefined') {
      this.loading = true
      this.uid = this.$route.params.uid
      this.key = this.$route.params.key
      this.send_form = false
      this.change_form = false
      this.$http.post('lostpass/key', {uid: this.uid, key: this.key}).then((res) => {
        this.loading = false
        this.change_form = true
        this.onePassword = res.body.data.onePassword
      }, (res) => {
        this.loading = false
        this.err_msg = 'LostPass.keyErr'
      })
    }
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>
